//Minified w/ JSMin: see https://github.com/1ec5/avim/blob/v5.4.0/content/kix.js
"use strict";(function(context){const Cc=Components.classes;const Ci=Components.interfaces;const CC=Components.Constructor;const nsTransferable=CC("@mozilla.org/widget/transferable;1","nsITransferable");function Transferable(win){let xfer=nsTransferable();if("init"in xfer){if(win instanceof Ci.nsIDOMWindow){win=win.QueryInterface(Ci.nsIInterfaceRequestor).getInterface(Ci.nsIWebNavigation);}
xfer.init(win);}
return xfer;}
function KixProxy(evt){if(evt.keyCode==evt.DOM_VK_BACK_SPACE&&!evt.shiftKey){throw"Backspace.";}
let doc=evt.originalTarget.ownerDocument;if(!doc||!doc.body)throw"No document body to copy from.";let win=doc.defaultView;let winUtils=win.QueryInterface(Ci.nsIInterfaceRequestor).getInterface(Ci.nsIDOMWindowUtils);if(!winUtils||!("sendKeyEvent"in winUtils&&"sendCompositionEvent"in winUtils&&"sendContentCommandEvent"in winUtils)){throw"Can't issue native events."}
let frame=win.frameElement;if(!frame)throw"Not in iframe.";let frameDoc=frame.ownerDocument;const overlaySelector=".kix-selection-overlay,.sketchy-text-selection-overlay";const presItemType="http://schema.org/CreativeWork/PresentationObject";const drawingItemType="http://schema.org/CreativeWork/DrawingObject";this.hasSelection=function(){return frameDoc.querySelectorAll(overlaySelector).length;};const isMac=win.navigator.platform=="MacPPC"||win.navigator.platform=="MacIntel";const tablePropsSel="[role='menuitem'][aria-disabled='false'] "+"[aria-label^='Table properties']";const altTextSel="[role='menuitem'][aria-disabled='false'] "+"[aria-label^='Alt text']";this.isInTable=function(){return frameDoc.querySelector(tablePropsSel);};let itemType=frame.ownerDocument.body.getAttribute("itemtype");this.isObjectSelected=function(){return itemType!=drawingItemType&&itemType!=presItemType&&frameDoc.querySelector(altTextSel);};this.selectPrecedingWord=function(toLineStart){ let key=(isMac||!toLineStart)?evt.DOM_VK_LEFT:evt.DOM_VK_HOME;let modifiers=(isMac||toLineStart)?evt.SHIFT_MASK:(evt.CONTROL_MASK|evt.SHIFT_MASK);if(isMac)modifiers|=toLineStart?evt.META_MASK:evt.ALT_MASK;winUtils.sendKeyEvent("keypress",key,0,modifiers);};const board=Cc["@mozilla.org/widget/clipboard;1"].getService(Ci.nsIClipboard);this.getClipboardData=function(){if(!board.hasDataMatchingFlavors(["text/unicode"],1,board.kGlobalClipboard)){return false;}
let xfer=Transferable(frameDoc.defaultView);xfer.addDataFlavor("text/unicode");board.getData(xfer,board.kGlobalClipboard);return xfer;};this.getClipboardText=function(){let xfer=this.getClipboardData();if(!xfer)return""; let str=new Object(),len=new Object();try{xfer.getTransferData("text/unicode",str,len);}
catch(exc){
return"\n";}
str=str&&str.value.QueryInterface(Ci.nsISupportsString);str=str&&str.data.substring(0,len.value/2);return str!="\ufeff"&&str;};this.revertSelection=function(){ winUtils.sendKeyEvent("keypress",evt.DOM_VK_RIGHT,0,0);};this.trimLeftSelection=function(){winUtils.sendKeyEvent("keypress",evt.DOM_VK_RIGHT,0,Event.SHIFT_MASK);};this.getSelectedText=function(isInTable){board.emptyClipboard(board.kGlobalClipboard);winUtils.sendContentCommandEvent("copy");let value=this.getClipboardText();if(!value){if(this.hasSelection())this.revertSelection();return"";}
if(!value.trim()){this.revertSelection();return"";}
return value;};
if(this.hasSelection())throw"Non-empty selection.";let wasInTable=this.isInTable(); this.selectPrecedingWord(wasInTable);if((!wasInTable&&this.isInTable())||this.isObjectSelected()){
this.trimLeftSelection();throw"Right after table or resizable object.";}
if(this.hasSelection()>1){

this.revertSelection();this.selectPrecedingWord(true);}
let value=this.getSelectedText();if(wasInTable&&value){
this.revertSelection();this.selectPrecedingWord(false);value=this.getSelectedText();}
if(!value)throw"No text.";if(!context.lastWordInString(value)){this.revertSelection();throw"No word.";}
this.value=this.oldValue=value;this.selectionStart=this.selectionEnd=this.value.length;this.commit=function(){ if(this.value==this.oldValue){if(this.value)this.revertSelection();return false;}






for(let i=0;i<this.value.length;i++){winUtils.sendKeyEvent("keydown",0,this.value.charCodeAt(i),0);winUtils.sendKeyEvent("keypress",0,this.value.charCodeAt(i),0);winUtils.sendKeyEvent("keyup",0,this.value.charCodeAt(i),0);}
return true;};}
context.lazyHandlers.kix=function(evt){let elt=evt.originalTarget;let doc=elt.ownerDocument;if("_avim_isBeingHandled"in elt||!("querySelector"in doc)){return false;}
let frame=doc.defaultView.frameElement;if(!frame||!("classList"in frame)||!(frame.classList.contains("docs-texteventtarget-iframe")||frame.classList.contains("kix-clipboard-iframe"))){return false;}
elt._avim_isBeingHandled=true;



const board=Cc["@mozilla.org/widget/clipboard;1"].getService(Ci.nsIClipboard);let xfer=Transferable(doc.defaultView);let flavors=["text/plain","text/unicode","text/x-moz-text-internal","text/html","AOLMAIL","image/png","image/jpeg","image/jpg","image/gif","application/x-moz-file",




"application/x-moz-nativeimage","application/x-moz-nativehtml",





"application/x-moz-private-browsing"];for(let i=0;i<flavors.length;i++)xfer.addDataFlavor(flavors[i]);board.getData(xfer,board.kGlobalClipboard);let result={};try{let proxy=new KixProxy(evt);result=proxy.value&&context.applyKey(proxy.value,evt);if(result&&result.value)proxy.value=result.value;proxy.commit();proxy=null;}
finally{delete elt._avim_isBeingHandled;board.setData(xfer,null,board.kGlobalClipboard);
}
if(result&&result.changed){evt.handled=true;evt.stopPropagation();evt.preventDefault();}
return true;};})(this);